package de.oaa.xxx.aufgaben.controller;

import de.oaa.xxx.aufgaben.Aufgabe;
import de.oaa.xxx.aufgaben.entity.AufgabeEntity;
import de.oaa.xxx.aufgaben.entity.AufgabenGruppeEntity;
import de.oaa.xxx.aufgaben.repository.AufgabeRepository;
import de.oaa.xxx.aufgaben.repository.AufgabenGruppeRepository;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.http.ResponseEntity;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.servlet.support.ServletUriComponentsBuilder;

import java.util.UUID;

@RestController
@RequestMapping("/aufgabe")
@Transactional
public class AufgabeController {

    private static final Logger LOGGER = LoggerFactory.getLogger(AufgabeController.class);

    private final AufgabeRepository aufgabeRepository;
    private final AufgabenGruppeRepository gruppeRepository;

    public AufgabeController(AufgabeRepository aufgabeRepository, AufgabenGruppeRepository gruppeRepository) {
        this.aufgabeRepository = aufgabeRepository;
        this.gruppeRepository = gruppeRepository;
    }

    @GetMapping("/{aufgabeId}")
    public ResponseEntity<Aufgabe> get(@PathVariable UUID aufgabeId) {
        return aufgabeRepository.findById(aufgabeId)
                .map(entity -> ResponseEntity.ok(entity.toAufgabe()))
                .orElse(ResponseEntity.noContent().build());
    }

    @PostMapping
    public ResponseEntity<Void> create(@RequestBody Aufgabe aufgabe) {
        if (aufgabe.getKurzText() == null || aufgabe.getText() == null || aufgabe.getLevel() == null || aufgabe.getGruppeId() == null) {
            return ResponseEntity.badRequest().build();
        }
        AufgabenGruppeEntity gruppeEntity = gruppeRepository.findById(aufgabe.getGruppeId()).orElse(null);
        if (gruppeEntity == null || gruppeEntity.getAufgaben().size() > 50) {
            return ResponseEntity.badRequest().build();
        }
        AufgabeEntity entity = AufgabeEntity.create(aufgabe, gruppeEntity);
        aufgabeRepository.save(entity);
        return ResponseEntity.created(
                ServletUriComponentsBuilder.fromCurrentRequest().path("/{id}").buildAndExpand(entity.getAufgabeId()).toUri()
        ).build();
    }

    @DeleteMapping
    public ResponseEntity<Void> delete(@RequestBody Aufgabe aufgabe) {
        try {
            aufgabeRepository.findById(aufgabe.getAufgabeId()).ifPresent(aufgabeRepository::delete);
            return ResponseEntity.accepted().build();
        } catch (Exception exception) {
            LOGGER.error(exception.getMessage(), exception);
            return ResponseEntity.internalServerError().build();
        }
    }
}
